--[[
                                G A D G E T S
      -----------------------------------------------------------------
                            wildtide@wildtide.net
                           DoomSprout: Rift Forums 
      -----------------------------------------------------------------
      Gadgets Framework   : v0.1.10
      Project Date (UTC)  : 2012-10-17T07:14:53Z
      File Modified (UTC) : 2012-08-05T20:16:03Z (Wildtide)
      -----------------------------------------------------------------     
--]]

local toc, data = ...
local AddonId = toc.identifier
local TXT = Library.Translate

function WT.VersionCheck(addon, major, minor, revision)
	local details = Inspect.Addon.Detail(addon)
	if not details then 
		return false, "Addon not found"
	end
	local version = details.toc.Version
	-- Handle development version
	if version == "v0.1.10" then
		return true
	end
	
	local v1, v2, v3 = version:match("%w*(%d+)%.(%d+)%.(%d+).*")
	if (v1 and v2 and v3) then
		n1 = tonumber(v1)
		n2 = tonumber(v2)
		n3 = tonumber(v3)
		if (n1 >= major) and (n2 >= minor) and (n3 >= revision) then
			return true
		else
			return false, "Incorrect version level"
		end
	else
		return false, "Failed to parse version number"
	end
end

if not WT.VersionCheck("Gadgets", 0, 3, 78) then
	Command.Console.Display("general", true, "<font color='#ffaa00'>Gadgets: Buffs requires Gadgets version 0.3.78 or later.\nPlease update to the latest version.</font>", true)
end