local nkRebuffInfo, nkRebuff = ...

nkRebuff.abilityBar = {}
nkRebuff.abilityIcon = {}

function nkRebuff.abilityBar:new(index, settings)

	local this = settings or {}
	this.index = index
	
	local scale = nkRBSetup.bars[index].scale / 100

	local width, height = ((50 * nkRBSetup.bars[index].noOfIcons) + (30 * (nkRBSetup.bars[index].noOfIcons-1))) * scale , 50 * scale
	if nkRBSetup.bars[index].align == 'vertical' then width, height = 50 * scale, ((50 * nkRBSetup.bars[index].noOfIcons) + (30 * (nkRBSetup.bars[index].noOfIcons-1))) * scale end	
		
	local bar = UI.CreateFrame ('nkExtFrame', 'nkRebuffAbilityBar', nkRebuff.UIelements.context, { layer = 2, width = width, height = height, anchors = {{from = "TOPLEFT", object = UIParent, to = "TOPLEFT", x = this.xpos, y = this.ypos}} })
	
	local moveWidth, moveHeight = width, height
	
	if nkRBSetup.bars[index].align == 'vertical' then 
		if nkRBSetup.bars[index].label == 1 then
			moveWidth = moveWidth + 50
		elseif nkRBSetup.bars[index].label == 2 then
			moveWidth = moveWidth + 100
		end		
	else
		if nkRBSetup.bars[index].label == 1 then
			moveHeight = moveHeight + (nkRBSetup.bars[index].fontsize * scale)
		elseif nkRBSetup.bars[index].label == 2 then
			moveHeight = moveHeight + (nkRBSetup.bars[index].fontsize * scale * 3)
		end	
	end	
	
	bar.moveframe = UI.CreateFrame ('nkExtFrame', 'nkRebuffAbilityBar', bar:getElement(false), { visible = false, layer = 2, color = { body = '0000FF', alphabody = 0.7}, width = moveWidth, height = moveHeight, anchors = {{from = "TOPLEFT", object = bar:getElement(), to = "TOPLEFT"}} })
	bar.moveIcon = UI.CreateFrame ('nkExtTexture', 'nkRebuffAbilityBarMoveIcon', bar.moveframe:getElement(false), { layer = 1, type = "nkRebuff", path = 'gfx/nkMoveIcon.png', alpha = 0.7, width = 20, height = 20, anchors = {{ from = "TOPLEFT", object = bar.moveframe:getElement(), to = "TOPLEFT"}} })
	bar.moveTitle = UI.CreateFrame ('nkExtText', 'nkRebuffAbilityBarMoveTitle', bar.moveframe:getElement(false), { layer = 2, text = settings.movelabel, color = 'FFFFFF', fontsize = 14, anchors = {{from = "CENTER", object = bar.moveframe:getElement(), to = "CENTER"}} })
	
	bar.moveframe:SetEvent('LeftDown', function()
		bar.MouseDown = true
		mouseData = Inspect.Mouse()
		if bar.props.anchors[1].x == nil then bar.props.anchors[1].x = 0 end
		if bar.props.anchors[1].y == nil then bar.props.anchors[1].y = 0 end
				
		bar.startX = mouseData.x - bar.props.anchors[1].x
		bar.startY = mouseData.y - bar.props.anchors[1].y
	end)
			
	bar.moveframe:SetEvent('MouseMove', function()
		if bar.MouseDown then
			mouseData = Inspect.Mouse()
			curdivX = mouseData.x - bar.startX
			curdivY = mouseData.y - bar.startY			
			
			local newAnchor = {{ from = bar.props.anchors[1].from, object = bar.props.anchors[1].object, to = bar.props.anchors[1].to, x = curdivX, y = curdivY }}
			bar:update ({ anchors = newAnchor })
			
			settings.moveFunc (curdivX, curdivY)
		end
	end)
		
	bar.moveframe:SetEvent('LeftUp', function() if bar.MouseDown then bar.MouseDown = false end end)
	
	this.icons = {}
	local parent = bar:getElement()
	
	local anchors = {{ from = "TOPLEFT", object = parent, to = "TOPLEFT" }} 	
	
	for i = 1, nkRBSetup.bars[index].noOfIcons, 1 do
		local icon = nkRebuff.abilityIcon:new (index, { id = i, parent = parent, anchors = anchors })
		
		if nkRBSetup.bars[index].align == 'vertical' then		
			anchors = {{ from = "TOPLEFT", object = icon.element:getElement(false), to = "BOTTOMLEFT", x = 0, y = 30 * scale }} 
		else
			anchors = {{ from = "TOPLEFT", object = icon.element:getElement(false), to = "TOPRIGHT", x = 30 * scale, y = 0 }}
		end
		
		table.insert (this.icons, icon)
	end
	
	this.bar = bar
	
	setmetatable(this, self)
	self.__index = self
	return this

end

function nkRebuff.abilityBar:Update()

	local scale = nkRBSetup.bars[self.index].scale / 100
	local frameSize = 50 * scale
	local iconSize = frameSize - 4
	local fontsize = nkRBSetup.bars[self.index].fontsize * scale
	
	local width, height = ((50 * nkRBSetup.bars[self.index].noOfIcons) + (30 * (nkRBSetup.bars[self.index].noOfIcons-1))) * scale , 50 * scale
	if nkRBSetup.bars[self.index].align == 'vertical' then width, height = 50 * scale, ((50 * nkRBSetup.bars[self.index].noOfIcons) + (30 * (nkRBSetup.bars[self.index].noOfIcons-1))) * scale end	
	
	self.bar:update ({ visible = true, width = width, height = height, anchors = {{from = "TOPLEFT", object = UIParent, to = "TOPLEFT", x = self.xpos, y = self.ypos}} })
	
	local moveWidth, moveHeight = width, height
	
	if nkRBSetup.bars[self.index].align == 'vertical' then 
		if nkRBSetup.bars[self.index].label == 1 then
			moveWidth = moveWidth + 50
		elseif nkRBSetup.bars[self.index].label == 2 then
			moveWidth = moveWidth + 100
		end		
	else
		if nkRBSetup.bars[self.index].label == 1 then
			moveHeight = moveHeight + (nkRBSetup.bars[self.index].fontsize * scale)
		elseif nkRBSetup.bars[self.index].label == 2 then
			moveHeight = moveHeight + (nkRBSetup.bars[self.index].fontsize * scale * 3)
		end	
	end

	self.bar.moveframe:update ({ width = moveWidth, height = moveHeight })
	
	local anchors = {{ from = "TOPLEFT", object = self.bar:getElement(), to = "TOPLEFT" }} 	

	local parent = self.bar:getElement()
	
	for i = 1, nkRBSetup.bars[self.index].noOfIcons, 1 do
		local icon = self.icons[i]
		
		if icon == nil then
			icon = nkRebuff.abilityIcon:new (self.index, { id = i, parent = parent, anchors = anchors })
			table.insert (self.icons, icon)
		else			
			icon.element:update({ anchors = anchors, width = frameSize, height = frameSize })
			icon.element.icon:update({ width = iconSize, height = iconSize })
						
			local tempValue = nkRBSetup.bars[self.index].stackPos:split('@')			
			local stacksAnchor = {{ from = tempValue[1], object = icon.element:getElement(), to = tempValue[2], x = tonumber(tempValue[3]), y = tonumber(tempValue[4]) }}
			local stacksAnchorShadow = {{ from = tempValue[1], object = icon.element:getElement(), to = tempValue[2], x = tonumber(tempValue[3])+2, y = tonumber(tempValue[4])+2 }}
			
			icon.element.stacksShadow:getElement():ClearAll()
			icon.element.stacksShadow:update ({ fontsize = nkRBSetup.bars[self.index].stackFontsize * scale, anchors = stacksAnchorShadow })
			
			icon.element.stacks:getElement():ClearAll()
			icon.element.stacks:update ({ fontsize = nkRBSetup.bars[self.index].stackFontsize * scale, anchors = stacksAnchor })

			local tempValue = nkRBSetup.bars[self.index].counterPos:split('@')
			local counterAnchor = {{ from = tempValue[1], object = icon.element:getElement(), to = tempValue[2], x = tonumber(tempValue[3]), y = tonumber(tempValue[4]) }}
			local counterShadowAnchor = {{ from = tempValue[1], object = icon.element:getElement(), to = tempValue[2], x = tonumber(tempValue[3]) + 2, y = tonumber(tempValue[4]) + 2 }}	
			
			--icon.element.counterShadow:getElement():ClearAll()
			icon.element.counterShadow:ClearWidth()
			icon.element.counterShadow:update ({ fontsize = nkRBSetup.bars[self.index].counterFontsize * scale, anchors = counterShadowAnchor })
			
			--icon.element.counter:getElement():ClearAll()
			icon.element.counter:ClearWidth()
			icon.element.counter:update ({ fontsize = nkRBSetup.bars[self.index].counterFontsize * scale, anchors = counterAnchor  })
	
			--icon.element.label1:getElement():ClearAll()
			--icon.element.label2:getElement():ClearAll()
			--icon.element.label3:getElement():ClearAll()
			icon.element.label1:ClearWidth()
			icon.element.label2:ClearWidth()
			icon.element.label3:ClearWidth()
			
			local showLabels = false
			if nkRBSetup.bars[self.index].label ~= 0 then showLabels = true end
			
			if nkRBSetup.bars[self.index].align == 'vertical' then  										
				icon.element.label1:update ( { visible = showLabels, anchors = {{ from = "CENTERLEFT", object = icon.element:getElement(), to = "CENTERRIGHT"}} })
				icon.element.label2:update ( { anchors = {{ from = "BOTTOMLEFT", object = icon.element.label1:getElement(), to = "TOPLEFT", x = 0, y = -3}} })				
				icon.element.label3:update ( { anchors = {{ from = "TOPLEFT", object = icon.element.label1:getElement(), to = "BOTTOMLEFT", x = 0, y = 3}} })
			else
				icon.element.label1:update ( { visible = showLabels, anchors = {{ from = "TOPCENTER", object = icon.element:getElement(), to = "BOTTOMCENTER"}} })
				icon.element.label2:update ( { anchors = {{ from = "TOPCENTER", object = icon.element.label1:getElement(), to = "BOTTOMCENTER", x = 0, y = 3}} })
				icon.element.label3:update ( { anchors = {{ from = "TOPCENTER", object = icon.element.label2:getElement(), to = "BOTTOMCENTER", x = 0, y = 3}} })
			end
		end
		
		if nkRBSetup.bars[self.index].align == 'vertical' then		
			anchors = {{ from = "TOPLEFT", object = icon.element:getElement(false), to = "BOTTOMLEFT", x = 0, y = 30 * scale }} 
		else
			anchors = {{ from = "TOPLEFT", object = icon.element:getElement(false), to = "TOPRIGHT", x = 30 * scale, y = 0 }}
		end
	end
	
	for i = nkRBSetup.bars[self.index].noOfIcons+1, 15, 1 do
		if self.icons[i] ~= nil then self.icons[i]:SetVisible(false) end
	end

end

function nkRebuff.abilityBar:setCoords ( xpos, ypos)

	self.xpos = xpos
	self.ypos = ypos

end

function nkRebuff.abilityBar:Moveable(flag) self.bar.moveframe:update ({ visible = flag }) end

function nkRebuff.abilityBar:SetVisible(flag) self.bar:SetVisible(flag) end
function nkRebuff.abilityBar:getElement() return self.bar:getElement() end

function nkRebuff.abilityIcon:new (index, settings)

	local this = settings or {}
	self.index = index
	
	local scale = nkRBSetup.bars[index].scale / 100
	local frameSize = 50 * scale
	local iconSize = frameSize - 4
	local fontsize = nkRBSetup.bars[index].fontsize * scale
	
	if nkRBSetup.bars[index].label == 1 then fontsize = fontsize + 2 end
			
	if nkRBSetup.bars[index].border == 0 then 
		iconSize = frameSize
	elseif nkRBSetup.bars[index].border == 1 then 
		iconSize = frameSize - 3
	elseif nkRBSetup.bars[index].border == 2 then 
		iconSize = frameSize - 5
	elseif nkRBSetup.bars[index].border == 3 then 
		iconSize = frameSize - 8
	end
	
	local color = nkRBSetup.bars[index].bcolor
	
	local frame = UI.CreateFrame ('nkExtFrame', 'icon' .. this.id, this.parent, { visible = false, width = frameSize, height = frameSize, color = { body = color }, anchors = this.anchors })
	
	frame.eventFrame = UI.CreateFrame ('nkExtFrame', 'icon' .. this.id .. 'eventFrame', frame:getElement(), { layer = 0, visible = false, width = frameSize, height = frameSize, anchors = {{ from = "CENTER", object = frame:getElement(), to = "CENTER"}} })
	frame.icon = UI.CreateFrame('nkExtTexture', 'icon' .. this.id .. 'icon', frame:getElement(), { layer = 1, width = iconSize, height = iconSize, anchors = {{ from = "CENTER", object = frame:getElement(false), to = "CENTER"}} })
	
	local tempValue = nkRBSetup.bars[index].stackPos:split('@')	
	
	local stacksAnchor = {{ from = tempValue[1], object = frame:getElement(), to = tempValue[2], x = tonumber(tempValue[3]), y = tonumber(tempValue[4]) }}
	local stacksAnchorShadow = {{ from = tempValue[1], object = frame:getElement(), to = tempValue[2], x = tonumber(tempValue[3])+2, y = tonumber(tempValue[4])+2 }}
	
	frame.stacksShadow = UI.CreateFrame('nkExtText', 'icon' .. this.id .. 'stacksShadow', frame:getElement(), { layer = 2, text = '9', fontsize = nkRBSetup.bars[index].stackFontsize * scale, color = "000000", anchors = stacksAnchorShadow })
	frame.stacks = UI.CreateFrame('nkExtText', 'icon' .. this.id .. 'stacks', frame.stacksShadow:getElement(), { text = '9', fontsize = nkRBSetup.bars[index].stackFontsize * scale, color = nkRBSetup.bars[index].stackColor, anchors = stacksAnchor })	
	
	local tempValue = nkRBSetup.bars[index].counterPos:split('@')
	
	local counterAnchor = {{ from = tempValue[1], object = frame:getElement(), to = tempValue[2], x = tonumber(tempValue[3]), y = tonumber(tempValue[4]) }}
	local counterShadowAnchor = {{ from = tempValue[1], object = frame:getElement(), to = tempValue[2], x = tonumber(tempValue[3]) + 2, y = tonumber(tempValue[4]) + 2 }}	
	
	frame.counterShadow = UI.CreateFrame('nkExtText', 'icon' .. this.id .. 'counterShadow', frame:getElement(), { layer = 3, text = '9', fontsize = nkRBSetup.bars[index].counterFontsize * scale, color = "000000", anchors = counterShadowAnchor })
	frame.counter = UI.CreateFrame('nkExtText', 'icon' .. this.id .. 'counter', frame.counterShadow:getElement(), { text = '9', fontsize = nkRBSetup.bars[index].counterFontsize * scale, color = nkRBSetup.bars[index].ccolor, anchors = counterAnchor })	
	
	local showLabels = false
	if nkRBSetup.bars[index].label ~= 0 then showLabels = true end
	
	if nkRBSetup.bars[index].align == 'vertical' then
		frame.label1 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label1', frame:getElement(false), {  visible = showLabels, autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRBSetup.bars[index].lcolor, anchors = {{ from = "CENTERLEFT", object = frame:getElement(), to = "CENTERRIGHT"}} })
		frame.label2 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label2', frame.label1:getElement(), {autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRBSetup.bars[index].lcolor, anchors = {{ from = "BOTTOMLEFT", object = frame.label1:getElement(), to = "TOPLEFT", x = 0, y = -3}} })
		frame.label3 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label3', frame.label2:getElement(), {autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRBSetup.bars[index].lcolor, anchors = {{ from = "TOPLEFT", object = frame.label1:getElement(), to = "BOTTOMLEFT", x = 0, y = 3}} })
	else
		frame.label1 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label1', frame:getElement(false), { visible = showLabels, autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRBSetup.bars[index].lcolor, anchors = {{ from = "TOPCENTER", object = frame:getElement(), to = "BOTTOMCENTER"}} })
		frame.label2 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label2', frame.label1:getElement(), {autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRBSetup.bars[index].lcolor, anchors = {{ from = "TOPCENTER", object = frame.label1:getElement(), to = "BOTTOMCENTER", x = 0, y = 3}} })
		frame.label3 = UI.CreateFrame ('nkExtText', 'icon' .. this.id .. 'label3', frame.label2:getElement(), {autowidth = true, height = 12 * scale, text = 'dummy', fontsize = fontsize, color = nkRBSetup.bars[index].lcolor, anchors = {{ from = "TOPCENTER", object = frame.label2:getElement(), to = "BOTTOMCENTER", x = 0, y = 3}} })
	end	

	frame.element:SetAlpha(nkRBSetup.bars[index].alpha)
	
	frame.eventFrame:SetEvent('LeftClick', function () 		
		nkRebuff.privateVars.tempHides[settings.type][settings.label] = true; 
		if nkRebuff.UIelements.tooltip ~= nil then nkRebuff.hideTooltip() end 
	end )
	
	frame.eventFrame:SetEvent('MouseIn', function() 
		local desc = ''
		if this.desc ~= nil then desc = this.desc else
			if this.ability ~= nil then
				local abilityInfo = Inspect.Ability.Detail(this.ability)			
				if abilityInfo ~= nil then desc = abilityInfo.description end
			end
		end
		
		local color = 'FFFFFF'
		if settings.type == 'buff' or settings.type == 'buffTarget' then
			color = '00FF21'
		elseif settings.type == 'debuff' then
			color = 'FF0000'
		elseif settings.type == 'debuff3rd' then
			color = 'FF0000'
		elseif settings.type == 'CD' or settings.type == 'ability' then
			color = '0094FF'
		end
		
		nkRebuff.showTooltip(nkRBSetup.bars[index].align, frame:getElement(), settings.label, color, desc, nkRebuff.langTexts.abilityBars.iconHelp)
	end)
	
	frame.eventFrame:SetEvent('MouseOut', function() 
		if nkRebuff.UIelements.tooltip ~= nil then nkRebuff.hideTooltip() end 
	end)
	
	this.element = frame

	setmetatable(this, self)
	self.__index = self
	return this
	
end

function nkRebuff.abilityIcon:SetVisible (flag) self.element:SetVisible(flag) end

function nkRebuff.abilityIcon:Update (index, settings)

	if settings == nil then return end
	self.type = settings.type
	self.label = settings.label
	self.desc = settings.desc
	self.ability = settings.ability
	
	if nkRBSetup.bars[index].hideOnLeftClick == true or nkRBSetup.bars[index].tooltip then
		self.element.eventFrame:SetVisible(true)
	else
		self.element.eventFrame:SetVisible(false)
	end
		
	if nkRBSetup.bars[index].border == 0 then 
		self.element.icon:update ({ width = self.element:GetWidth(), height = self.element:GetHeight() })
	elseif nkRBSetup.bars[index].border == 1 then 
		self.element.icon:update ({ width = self.element:GetWidth() - 3, height = self.element:GetHeight() - 3 })
	elseif nkRBSetup.bars[index].border == 2 then 
		self.element.icon:update ({ width = self.element:GetWidth() - 5, height = self.element:GetHeight() - 5 })
	elseif nkRBSetup.bars[index].border == 3 then 
		self.element.icon:update ({ width = self.element:GetWidth() - 8, height = self.element:GetHeight() - 8 })
	end
	
	local color = nkRBSetup.bars[index].bcolor
	self.element:update ({ color = { body = color } })
		
	local temp = nil
	
	if nkRBSetup.bars[index].label ~= 0 then
		if nkRBSetup.bars[index].label == 1 then
			local tempValue = ''
			local shortenedText = ''
			if string.find (settings.label, ' ') == nil and string.find(settings.label, '-') ~= nil then
				 tempValue = string.split(settings.label, '-')
			else
				 tempValue = string.split(settings.label, ' ')
			end
			
			for idx2 = 1, #tempValue, 1 do
				shortenedText = shortenedText .. string.sub (tempValue[idx2], 1, 1)
			end		
			temp = {shortenedText}
		else
			temp = string.split(settings.label, ' ' )
			if string.find (settings.label, ' ') == nil and string.find(settings.label, '-') ~= nil then temp = string.split(settings.label, '-') end
		end

		if nkRBSetup.bars[index].align == 'vertical' then		
			if temp[3] ~= nil then 
				temp[2], temp[1] = temp[1], temp[2] 
			elseif temp[2] ~= nil then
				temp[2], temp[1] = temp[1], temp[2] 
			end
		end
		
		for idx = 1, 3, 1 do if temp[idx] == nil then temp[idx] = '' end end
				
		self.element.label1:update ({ visible = true, text = temp[1], color = nkRBSetup.bars[index].lcolor })
		self.element.label2:update ({ text = temp[2], color = nkRBSetup.bars[index].lcolor })
		self.element.label3:update ({ text = temp[3], color = nkRBSetup.bars[index].lcolor })
	end

	self.element.icon:SetTexture({ type = "Rift", path = settings.texture })
		
	local scale = nkRBSetup.bars[index].scale / 100
		
	if settings.remaining == nil or settings.remaining == -1 then 	
		self.element.counterShadow:SetVisible(false)
		self.element:getElement():SetAlpha ( nkRBSetup.bars[index].alpha ) 
	else
		local remainingRound = nkTools.math.round((settings.remaining + nkRBSetup.basic.counterCorrection), 0)
		if remainingRound < 0 then remainingRound = 0 end
				
		local fontsize = nkRBSetup.bars[index].counterFontsize * scale
		
		if remainingRound > 60 then
			remainingRound = nkTools.math.round(remainingRound / 60, 0)
			remainingRoundText = tostring(remainingRound)..'M'
			
			if remainingRound > 9 then fontsize = (nkRBSetup.bars[index].counterFontsize-8) * scale end
		else
			if remainingRound < 10 then fontsize = (nkRBSetup.bars[index].counterFontsize+10) * scale end
			remainingRoundText = tostring(remainingRound)
		end
		
		self.element.counterShadow:update({ text = remainingRoundText, fontsize = fontsize })
		self.element.counter:update({ text = remainingRoundText, fontsize = fontsize })
				
		self.element.counterShadow:SetVisible(true)
		if nkRBSetup.bars[index].cbFadein == true then self.element:getElement():SetAlpha ( nkRBSetup.bars[index].alpha - (nkRBSetup.bars[index].alpha / nkRBSetup.bars[index].runoutDuration * remainingRound)) end
	end
	
	if settings.stack == nil then
		self.element.stacksShadow:SetVisible(false)
	else		
		local fontsize = nkRBSetup.bars[index].stackFontsize * scale
		if settings.stack < 10 then fontsize = (nkRBSetup.bars[index].stackFontsize+10) * scale end
	
		self.element.stacksShadow:update({ text = tostring(settings.stack), fontsize = fontsize })
		self.element.stacks:update({ text = tostring(settings.stack), fontsize = fontsize })
		
		self.element.stacksShadow:SetVisible(true)
	end	
	
	self:SetVisible(true)

end
