local nkRebuffInfo, nkRebuff = ...

nkRebuff.const = {
	barBuffsID = 1,
	barDebuffsID = 2,
	barDebuffsPlayerID = 3,	
	barCooldownsID = 4,
	barAbilitiesID = 5,
	barWarningsID = 6,
	barbuffTargetID = 7
}


nkRebuff.privateVars = {}

nkRebuff.privateVars.addonName = "nkRebuff"
nkRebuff.privateVars.addonVersion = "2.4.1"
nkRebuff.privateVars.tempHides = {buff = {}, debuff = {}, CD = {}, debuff3rd = {}, ability = {}, buffTarget = {}}
nkRebuff.privateVars.activeCDList = {}
nkRebuff.privateVars.brEventInit = false
nkRebuff.privateVars.brRoleChangeInit = false
nkRebuff.privateVars.performance = { buffs = false, cooldowns = false, debuffs = false, debuffsPlayer = false, buffTarget = false }
nkRebuff.privateVars.barsLocked = true
nkRebuff.privateVars.lastDebuffs = {}

nkRebuff.privateVars.fixedIconPos = {}

nkRebuff.UIelements = {}
nkRebuff.UIelements.context = UI.CreateContext("nkRebuffBar")
nkRebuff.UIelements.configContext = UI.CreateContext ("nkRebuffConfig")
nkRebuff.UIelements.configContext:SetStrata ('modal')

function nkRebuff.main(addon)

	if (addon == nkRebuff.privateVars.addonName) then
		
		-- nkRebuff.privateVars.mainLog = nkLog.log:new('nkRebuff', 'main')
		-- nkRebuff.privateVars.mainLog:logMessage ('nkRebuff started', nkLog.levelInfo)	
		
		if nkRBSetup.basic.doRecognition == true then 
			table.insert(Event.Buff.Add, {nkRebuff.events.BuffAdd , "nkRebuff", "buffAdded"}) 
			table.insert(Event.Ability.Cooldown.Begin, { nkRebuff.events.cooldownBegin, "nkRebuff", "CDBegin"})
			nkRebuff.privateVars.brEventInit = true
		end
		
		if nkRBSetup.basic.autoRoleSwitch == true then 
			table.insert(Event.Unit.Detail.Role, {nkRebuff.events.roleChange, "nkRebuff", "roleChange"})
			nkRebuff.privateVars.brRoleChangeInit = true
		end
		
		table.insert(Event.System.Update.Begin, {nkRebuff.events.updateHandler, "nkRebuff", "eventHandler"})
		table.insert(Command.Slash.Register("nkRebuff"), {nkRebuff.commandHandler, "nkRebuff", "config"})
		table.insert(Command.Slash.Register("nkr"), {nkRebuff.commandHandler, "nkRebuff", "config"})
		table.insert(Command.Slash.Register("nkrb"), {nkRebuff.commandHandler, "nkRebuff", "config"})
		
		local items = {
		{ label = nkRebuff.langTexts.various.buttonMenuConfig, func = function () if nkRebuff.UIelements.configUI == nil then nkRebuff.UIelements.configUI = nkRebuff.Config:new() else nkRebuff.UIelements.configUI:Show(true) end end},
		{ seperator = true },
		{ label = nkRebuff.langTexts.various.buttonMenuResetTempHides, func = function () nkRebuff.clearTempHides() end}}

		for idx = 1, #nkRBSetup.sets, 1 do
			table.insert (items, { label = nkRBSetup.sets[idx].name, func = function() nkRebuff.activateSet (idx) end })
		end
		
		nkManager.init('nkRebuff', items, nil)
		
		nkRebuff.performanceCheck()
		nkRebuff.buildBars()
				
		print (string.format(nkRebuff.langTexts.various.msgLoaded, nkRebuff.langTexts.various.version, nkRebuff.privateVars.addonVersion))
	end
	
end

function nkRebuff.commandHandler(commandline)

	if string.find(commandline, 'set=') ~= nil then
		local pos = string.find(commandline, 'set=')
		local setno = tonumber(string.sub(commandline, pos+4, string.len(commandline)))
		
		if setno < 1 or setno > #nkRBSetup.sets then
			print (string.format(nkRebuff.langTexts.various.commandSetRefuse, #nkRBSetup.sets))
		else
			nkRebuff.activateSet (setno)
		end
	else
		if nkRebuff.UIelements.configUI == nil then
			nkRebuff.UIelements.configUI = nkRebuff.Config:new()
		else
			nkRebuff.UIelements.configUI:Show(true)
		end
	end
	
end

function nkRebuff.settingsHandler(addon) 

	if (addon == nkRebuff.privateVars.addonName) then	
	
		local settings = {
			basic = { remainingWarning = true, showBarsDuringConfig = true, active = true, gcd = 1, activeSet = 1,throttle = 1, combatOnly = false, locked = true, autoRoleSwitch = false, debuffWarning = true, doRecognition = true, newDebuffActive = true, counterCorrection = 0},
			sets = { { role = 0, name = 'default', buff = {}, buff3rd = {}, debuff = {}, debuff3rd = {}, CD = {}, buffTarget = {} } },
			bars = {{counterFontsize = 30, stackFontsize = 20, counterPos = 'CENTER@CENTER@0@0', stackPos = 'TOPRIGHT@TOPRIGHT@2@-4', stackColor = '7F0000', tooltip = true, hideOnLeftClick = true, runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 200, scale = 100, border = 2, label = 2, bcolor = '000000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, align = 'centered', cbFadein = false, alpha = 1 },
					{counterFontsize = 30, stackFontsize = 20, counterPos = 'CENTER@CENTER@0@0', stackPos = 'TOPRIGHT@TOPRIGHT@2@-4', stackColor = '7F0000', tooltip = true, hideOnLeftClick = true, runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 275, scale = 100, border = 2, label = 2, bcolor = '7F0000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, align = 'centered', cbFadein = false, alpha = 1},
					{counterFontsize = 30, stackFontsize = 20, counterPos = 'CENTER@CENTER@0@0', stackPos = 'TOPRIGHT@TOPRIGHT@2@-4', stackColor = '7F0000', tooltip = true, hideOnLeftClick = true, runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 350, scale = 100, border = 2, label = 2, bcolor = '7F0000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, align = 'centered', cbFadein = false, alpha = 1},
					{counterFontsize = 30, stackFontsize = 20, counterPos = 'CENTER@CENTER@0@0', stackPos = 'TOPRIGHT@TOPRIGHT@2@-4', stackColor = '7F0000', tooltip = true, hideOnLeftClick = true, runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 425, scale = 100, border = 2, label = 2, bcolor = '000000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, align = 'centered', cbFadein = false, alpha = 1},
					{counterFontsize = 30, stackFontsize = 20, counterPos = 'CENTER@CENTER@0@0', stackPos = 'TOPRIGHT@TOPRIGHT@2@-4', stackColor = '7F0000', tooltip = true, hideOnLeftClick = true, runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 500, scale = 100, border = 2, label = 2, bcolor = '000000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, align = 'centered', cbFadein = false, alpha = 1},
					{counterFontsize = 30, stackFontsize = 20, counterPos = 'CENTER@CENTER@0@0', stackPos = 'TOPRIGHT@TOPRIGHT@2@-4', stackColor = '7F0000', tooltip = true, hideOnLeftClick = true, runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 575, scale = 150, border = 2, label = 2, bcolor = '000000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =14, align = 'centered', cbFadein = false, alpha = 1},
					{counterFontsize = 30, stackFontsize = 20, counterPos = 'CENTER@CENTER@0@0', stackPos = 'TOPRIGHT@TOPRIGHT@2@-4', stackColor = '7F0000', tooltip = true, hideOnLeftClick = true, runoutDuration = 6, noOfIcons = 7, xpos = 687, ypos = 650, scale = 100, border = 2, label = 2, bcolor = '000000', ccolor = '7F0000', lcolor = 'FFFFFF', fontsize =16, align = 'centered', cbFadein = false, alpha = 1} },
			data = { buff = {}, buff3rd = {}, debuff = {}, debuff3rd = {}, CD = {} },
		}
			
		if nkRBSetup == nil then
			nkRBSetup = settings
		else
			for k, v in pairs (settings) do 
				if nkRBSetup[k] == nil then 
					nkRBSetup[k] = v
				elseif k == 'basic' then
					for l, w in pairs (v) do
						if nkRBSetup.basic[l] == nil then nkRBSetup.basic[l] = w end
					end
				elseif k == 'bars' then
					for idx = 1, #v, 1 do						
						if nkRBSetup.bars[idx] == nil then nkRBSetup.bars[idx] = {} end
						
						for l, w in pairs (v[idx]) do
							if nkRBSetup.bars[idx][l] == nil then nkRBSetup.bars[idx][l] = w end
						end
						
						if string.find(nkRBSetup.bars[idx].counterPos, '-') ~= nil then 
							local startPos, endPos = string.find(nkRBSetup.bars[idx].counterPos, '-')
							if string.sub (nkRBSetup.bars[idx].counterPos, startPos-1, endPos-1) ~= '@' then
								nkRBSetup.bars[idx].counterPos = string.gsub (nkRBSetup.bars[idx].counterPos, '-', '@', 1)
							end
						end
						
						if string.find(nkRBSetup.bars[idx].stackPos, '-') ~= nil then 
							local startPos, endPos = string.find(nkRBSetup.bars[idx].stackPos, '-')
							if string.sub (nkRBSetup.bars[idx].stackPos, startPos-1, endPos-1) ~= '@' then
								nkRBSetup.bars[idx].stackPos = string.gsub (nkRBSetup.bars[idx].stackPos, '-', '@', 1)
							end
						end
					end
				end 				
			end
		end

		-- add new tracking item buffTarget to existing sets if missing
		
		for k, v in pairs (nkRBSetup.sets) do
			if nkRBSetup.sets[k].buffTarget == nil then nkRBSetup.sets[k].buffTarget = {} end
		end

		if nkRBGlobal == nil then nkRBGlobal = {} end
				
		nkRBSetup.addonVersion = nkRebuff.privateVars.addonVersion		
	end
		
end

function nkRebuff.performanceCheck(showAll)

	if showAll == true then
		nkRebuff.privateVars.performance = { warning = true, buffs = true, cooldowns = true, debuffs = true, debuffsPlayer = true, buffTarget = true }
	else
		nkRebuff.privateVars.performance = { warning = nkRBSetup.basic.remainingWarning, buffs = false, cooldowns = false, debuffs = false, debuffsPlayer = nkRBSetup.basic.debuffWarning, buffTarget = false }
		
		for k, v in pairs (nkRBSetup.sets[nkRBSetup.basic.activeSet].buff) do
			if v.active == true then
				nkRebuff.privateVars.performance.buffs = true
				break
			end
		end
		
		if nkRebuff.privateVars.performance.buffs == false then	
			for k, v in pairs (nkRBSetup.sets[nkRBSetup.basic.activeSet].buff3rd) do
				if v.active == true then
					nkRebuff.privateVars.performance.buffs = true
					break
				end
			end
		end
		
		for k, v in pairs (nkRBSetup.sets[nkRBSetup.basic.activeSet].debuff) do
			if v.active == true then
				nkRebuff.privateVars.performance.debuffs = true
				break
			end
		end
		
		for k, v in pairs (nkRBSetup.sets[nkRBSetup.basic.activeSet].CD) do
			if v.active == true then
				nkRebuff.privateVars.performance.cooldowns = true
				break
			end
		end
		
		for k, v in pairs (nkRBSetup.sets[nkRBSetup.basic.activeSet].buffTarget) do
			if v.active == true then
				nkRebuff.privateVars.performance.buffTarget = true
				break
			end
		end

	end
	
end

-- sub routines

function nkRebuff.activateSet (set)
	
	if set > #nkRBSetup.sets then return end
	
	print (string.format(nkRebuff.langTexts.various.activateSet, nkRBSetup.sets[set].name))
	nkRBSetup.basic.activeSet = set	
	nkRebuff.performanceCheck()
	
	if nkRebuff.UIelements.configUI ~= nil then nkRebuff.UIelements.configUI:Update() end
	
end

function nkRebuff.showTooltip(orientation, parent, title, color, descText, helpText)

	local anchors = {{ from = "TOPLEFT", object = parent, to = "BOTTOMLEFT" }}
	if orientation == 'vertical' then
		anchors = {{ from = "TOPLEFT", object = parent, to = "TOPRIGHT" }}
	end
	
	if nkRebuff.UIelements.tooltip == nil then nkRebuff.UIelements.tooltip = UI.CreateFrame('nkExtItemTooltip', 'nkRebuffTooltip', nkRebuff.UIelements.context, {}) end
	
	local lines = { { text = descText, width = 300 } }
	local addInfoLines = { { text = '', width = 300, height = 8 }, { text = helpText, width = 300 } }
	
	nkRebuff.privateVars.tooltipShowTime = Inspect.Time.Real()
	
	nkRebuff.UIelements.tooltip:update ({ title = title, titleColor = color, lines = lines, addInfoLines = addInfoLines, anchors = anchors })
	
end

function nkRebuff.hideTooltip()

	nkRebuff.privateVars.tooltipShowTime = nil
	nkRebuff.UIelements.tooltip:SetVisible(false)

end

function nkRebuff.clearTempHides()

	nkRebuff.privateVars.tempHides['buff'] = {}
	nkRebuff.privateVars.tempHides['debuff'] = {}
	nkRebuff.privateVars.tempHides['CD'] = {}
	nkRebuff.privateVars.tempHides['ability'] = {}
	nkRebuff.privateVars.tempHides['debuff3rd'] = {}
	nkRebuff.privateVars.tempHides['buffTarget'] = {}

end

function nkRebuff.addAbility(abilityType, name, active)

	for i = 1, #nkRBSetup.sets, 1 do
		nkRBSetup.sets[i][abilityType][name] = {}
		nkRBSetup.sets[i][abilityType][name].stackType = 0
		nkRBSetup.sets[i][abilityType][name].stackCount = 0
		nkRBSetup.sets[i][abilityType][name].customRemaining = false
		nkRBSetup.sets[i][abilityType][name].sortPrio = 10
		nkRBSetup.sets[i][abilityType][name].nat = false
		nkRBSetup.sets[i][abilityType][name].dnw = false
		nkRBSetup.sets[i][abilityType][name].nms = false
		nkRBSetup.sets[i][abilityType][name].sco = false
		nkRBSetup.sets[i][abilityType][name].active = active
	end

end

table.insert(Event.Addon.Load.End, {nkRebuff.main, "nkRebuff", "addonLoaded"})
table.insert(Event.Addon.SavedVariables.Load.End, {nkRebuff.settingsHandler, "nkRebuff", "vaiablesLoaded"})