local nkWardrobeInfo, nkWardrobe = ...

nkWardrobe.Button = { }
nkWardrobe.Tooltip = { }

function nkWardrobe.Button:new(settings)
	
	local this = settings or {}
	
	local button = nil
	local buttonSize = 64 * nkWardrobeSettings.scale / 100
	local iconSize = 48 * nkWardrobeSettings.scale / 100
		
	if nkWardrobeSettings.border == true then
		button = UI.CreateFrame ('nkExtTexture', 'nkWardrobeButton', nkWardrobe.UIelements.context, {type = 'nkWardrobe', path = 'ressource/button.png', width = buttonSize, height = buttonSize, anchors = {{ from = "TOPRIGHT", object = UIParent, to = "TOPRIGHT", x = nkWardrobeSettings.buttonX, y = nkWardrobeSettings.buttonY }} })
	else	
		button = UI.CreateFrame ('nkExtFrame', 'nkWardrobeButton', nkWardrobe.UIelements.context, { color = { body = '000000'}, width = buttonSize, height = buttonSize, anchors = {{ from = "TOPRIGHT", object = UIParent, to = "TOPRIGHT", x = nkWardrobeSettings.buttonX, y = nkWardrobeSettings.buttonY }} })
		iconSize = buttonSize
	end
	
	button:SetSecureMode('restricted')
	
	button:SetEvent('LeftClick', function()
		if Inspect.System.Secure() == false then
			if nkWardrobe.Button.tooltip ~= nil then nkWardrobe.Button.tooltip:SetVisible(false) end
			self:ToggleButtons()
		end
	end)
	button:SetEvent('MiddleClick', function() 
		if Inspect.System.Secure() == false and nkWardrobe.configUI == nil then nkWardrobe.configUI = nkWardrobe.Config:new() else nkWardrobe.configUI:Show(true) end 
	end)
		
	button:SetEvent('RightDown', function(element)
		if Inspect.System.Secure() == false then
			element.MouseDown = true
			mouseData = Inspect.Mouse()			
			element.startX = mouseData.x
			element.startY = mouseData.y
		end
	end)
			
	button:SetEvent('MouseMove', function(element)
		if element.MouseDown then
			mouseData = Inspect.Mouse()
			curdivX = mouseData.x - element.startX
			curdivY = mouseData.y - element.startY
			button:update({ anchors = {{ from = "TOPRIGHT", object = UIParent, to = "TOPRIGHT", x = nkWardrobeSettings.buttonX + curdivX, y = nkWardrobeSettings.buttonY + curdivY }} })
		end
	end)
	
	button:SetEvent('RightUp', function(element) 
		if element.MouseDown then 
			element.MouseDown = false 
			curdivX = mouseData.x - element.startX
			curdivY = mouseData.y - element.startY
			nkWardrobeSettings.buttonX = nkWardrobeSettings.buttonX + curdivX
			nkWardrobeSettings.buttonY = nkWardrobeSettings.buttonY + curdivY
		end 
	end)
	
	button:SetEvent ('MouseIn', function ()
		if Inspect.System.Secure() == false then
			self.ttCounter = 0
			self:ShowHelp()
		end
	end)
	
	button:SetEvent ('MouseOut', function ()
		if Inspect.System.Secure() == false and 0 == self.ttCounter then
			self.ttCounter = nil
			if nkWardrobe.Button.tooltip ~= nil then nkWardrobe.Button.tooltip:SetVisible(false) end
		end
	end)
	
	--	local path = 'ressource/'.. nkWardrobe.privateVars.calling .. nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].icon .. '.png'	
	
	local iconPath = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].icon
	if tonumber(nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].icon) ~= nil then iconPath = 'ressource/'.. nkWardrobe.privateVars.calling .. nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].icon .. '.png' end		
	
	local iconType = 'Rift'
	if string.find (iconPath, 'ressource/') ~= nil then iconType = 'nkWardrobe' end
	
	button.icon = UI.CreateFrame ('nkExtTexture', 'nkWardrobeButtonIcon', button:getElement(), {type = iconType, path = iconPath, width = iconSize, height = iconSize, anchors = {{ from = "CENTER", object = button:getElement(), to = "CENTER" }} })
	button.icon:SetSecureMode('restricted')
	
	local anchors = nil
	
	if nkWardrobeSettings.open == 'bottom' then
		anchors = {{ from = 'TOPLEFT', object = button:getElement(), to = 'BOTTOMLEFT', x = 0, y = 0 }}
		if nkWardrobeSettings.border == false then anchors[1].y = -5 end
	elseif nkWardrobeSettings.open == 'top' then	
		anchors = {{ from = 'BOTTOMLEFT', object = button:getElement(), to = 'TOPLEFT', x = 0, y = 0 }}
		if nkWardrobeSettings.border == false then anchors[1].y = 5 end
	elseif nkWardrobeSettings.open == 'left' then
		anchors = {{ from = 'CENTERRIGHT', object = button:getElement(), to = 'CENTERLEFT', x = 0, y = 0 }}
		if nkWardrobeSettings.border == false then anchors[1].x = -5 end
	elseif nkWardrobeSettings.open == 'right' then
		anchors = {{ from = 'CENTERLEFT', object = button:getElement(), to = 'CENTERRIGHT', x = 0, y = 0 }}
		if nkWardrobeSettings.border == false then anchors[1].x = 5 end
	end	
	
	local counter = 1
	if self.buttons == nil then self.buttons = {} end
	
	for k, v in pairs (nkWardrobeSettings.sets) do
	
		--local subpath = 'ressource/'.. nkWardrobe.privateVars.calling .. v.icon .. '.png'
		
		local subIconPath = v.icon
		
		-- Alte Icon Zuordnung ber Nummer supporten
		
		if tonumber(v.icon) ~= nil then subIconPath = 'ressource/'.. nkWardrobe.privateVars.calling .. v.icon .. '.png' end		
		
		local subIconType = 'Rift'
		if string.find (subIconPath, 'ressource/') ~= nil then subIconType = 'nkWardrobe' end
		
		local subButton = nil
	
		if self.buttons[counter] == nil then
	
			subButton = nil
			
			if nkWardrobeSettings.border == true then
				subButton = UI.CreateFrame ('nkExtTexture', 'nkWardrobeButton', button:getElement(), {type = 'nkWardrobe', path = 'ressource/button.png', width = buttonSize, height = buttonSize, anchors = anchors })
			else
				subButton = UI.CreateFrame ('nkExtFrame', 'nkWardrobeButton', nkWardrobe.UIelements.context, { width = buttonSize, height = buttonSize, anchors = anchors })
			end
			
			subButton:SetVisible(false)
			subButton:SetSecureMode ('restricted')
						
			subButton.icon = UI.CreateFrame ('nkExtTexture', 'nkWardrobeButtonIcon', subButton:getElement(), {type = subIconType, path = subIconPath, width = iconSize, height = iconSize, anchors = {{ from = "CENTER", object = subButton:getElement(), to = "CENTER" }} })
			subButton.icon:SetSecureMode('restricted')
			
			subButton:SetEvent ('MouseIn', function ()
				self.ttCounter = k
				self:ShowTooltip(k)
			end)
			
			subButton:SetEvent ('MouseOut', function ()
				if k == self.ttCounter then
					self.ttCounter = nil
					if nkWardrobe.Button.tooltip ~= nil then nkWardrobe.Button.tooltip:SetVisible(false) end
				end
			end)
			
			table.insert (self.buttons, subButton)
		else
			subButton = self.buttons[counter]
			subButton:update ({ anchors = anchors })
			subButton:SetVisible (false)
			
			subButton.icon:SetTexture ({ type = subIconType, path = subIconPath })
		end
		
		subButton:SetEvent ('LeftClick', function() 
			if Inspect.System.Secure() == false then
				nkWardrobeSettings.activeSet = k
				nkWardrobe.wearEquip(v.equipment)				
				button.icon:SetTexture ({ type = subIconType, path = subIconPath })
				self:ToggleButtons()
				
				local addons = Inspect.Addon.List()		
				if addons.nkRebuff ~= nil and v.nkrebuff ~= -1 then nkRBAPI.activateSet(v.nkrebuff) end				
				if nkWardrobe.Button.tooltip ~= nil then nkWardrobe.Button.tooltip:SetVisible(false) end
			end
		end)
		
		local macro = string.format ('role %d', v.role)
		local addonList = Inspect.Addon.List()
			
		if addonList.kAlert ~= nil then 
			if v.KAMain ~= nil and v.KAMain ~= -1 then macro = macro .. string.format('\nkaruulalert set=%d', v.KAMain) end
			if v.KASub ~= nil and v.KASub ~= -1 then macro = macro .. string.format('\nkaruulalert subset=%d', v.KASub) end
		end
		
		subButton:SetMacro ('LeftClick', macro)
				
		anchors[1].object = subButton:getElement()
		counter = counter + 1
		
	end
	
	for idx = counter, 1, #self.buttons do
		self.buttons[idx]:SetVisible(false)
	end
		
	nkWardrobe.Button.element = button
	
	self.element = button
	
	setmetatable(this, self)
	self.__index = self
	return this

end

function nkWardrobe.Button:ToggleButtons()

	local flag = self.showButtonFlag
	if flag == true then
		flag = false
	else
		flag = true
	end
	self.showButtonFlag = flag

	for idx = 1, #nkWardrobeSettings.sets, 1 do
		if self.buttons[idx] ~= nil then self.buttons[idx]:SetVisible(flag) end
	end

end

function nkWardrobe.Button:ShowTooltip(counter)

	local anchorElement = self.buttons[counter]:getElement()
	local set = nkWardrobeSettings.sets[counter]
	
	if set == nil then return end

	local from, to = "BOTTOM", "TOP"
	
	if nkWardrobeSettings.buttonY < 100 then from = "TOP" end
	
	if nkWardrobeSettings.buttonX > -250 then 
		from = from .. 'RIGHT'
		to = to .. 'LEFT'
	else
		from = from .. 'LEFT'
		to = to .. 'RIGHT'
	end
		
	local anchors = {{ from = from, object = anchorElement, to = to }}
	
	if nkWardrobe.Button.tooltip == nil then nkWardrobe.Button.tooltip = UI.CreateFrame('nkExtItemTooltip', 'nkWardrobeTooltip', self.element:getElement(), {}) end
	
	local lines = { { text = nkWardrobe.langTexts.fldRole .. ': ' .. set.role }, { text = nkWardrobe.langTexts.fldEquipment .. ': ' .. nkWardrobeSettings.equipSets[set.equipment].name } }
	
	local addonList = Inspect.Addon.List()			
	
	if addonList.nkRebuff ~= nil and set.nkrebuff ~= -1 then 
		local nkRebuffSets = nkRBAPI.getSets()
		if nkRebuffSets[set.nkrebuff] ~= nil then table.insert (lines, { text = nkWardrobe.langTexts.fldRebuff .. ': ' .. nkRebuffSets[set.nkrebuff].name }) end
	end
	
	if addonList.kAlert ~= nil and set.KAMain ~= nil then
		if set.KAMain ~= -1 then table.insert (lines, { text = nkWardrobe.langTexts.fldKASetMain .. ': ' .. set.KAMain }) end
		if set.KASub ~= -1 then table.insert (lines, { text = nkWardrobe.langTexts.fldKASetSub .. ': ' .. set.KASub }) end
	end
	
	local addLines = { { text = '', height = 8, }, { text = nkWardrobe.langTexts.equipTooltip } }
	
	nkWardrobe.Button.tooltip:update ({ parent = self.element:getElement(), title = set.name, lines = lines, anchors = anchors, addInfoLines = addLines })
	
end

function nkWardrobe.Button:ShowHelp()

	local anchorElement = self.element:getElement()

	local from, to = "BOTTOM", "TOP"
	
	if nkWardrobeSettings.buttonY < 100 then from = "TOP" end
	
	if nkWardrobeSettings.buttonX > -250 then 
		from = from .. 'RIGHT'
		to = to .. 'LEFT'
	else
		from = from .. 'LEFT'
		to = to .. 'RIGHT'
	end
		
	local anchors = {{ from = from, object = anchorElement, to = to }}
	
	if nkWardrobe.Button.tooltip == nil then nkWardrobe.Button.tooltip = UI.CreateFrame('nkExtItemTooltip', 'nkWardrobeTooltip', self.element:getElement(), {}) end
	
	local lines = { { text = nkWardrobe.langTexts.helpLine1 }, { text = nkWardrobe.langTexts.helpLine2 }, { text = nkWardrobe.langTexts.helpLine3 } }
	
	nkWardrobe.Button.tooltip:update ({ parent = self.element:getElement(), title = nkWardrobe.langTexts.helpTitle, lines = lines, anchors = anchors })

end
