local nkWardrobeInfo, nkWardrobe = ...

nkWardrobe.Config = { 
	cbTemplate = {labelinfront = true, labelwidth = 101, fontsize = 13, color = {border = 'ECE4BD', body = '000000', label = 'ECE4BD' }},
	comboTemplate = { color = {border = '666666', body = '000000', label = 'ECE4BD'}, width = 150, fontsize = 13, height = 19 },
	textTemplate = { color = 'ECE4BD', fontsize = 13},
	fldTemplate = { width = 40, height = 20, fontsize = 13, labelwidth = 100, color = { label = 'ECE4BD', border = '666666', body = '000000', focus = '999999' } },
	textHeaderTemplate = { color = 'FFFFFF', fontsize = 16},
	textHeaderShadowTemplate = { color = '000000', fontsize = 16},
}

nkWardrobe.UIelements.context:SetSecureMode('restricted')

function nkWardrobe.Config:new(settings)
	
	local this = settings or {}

	if nkWardrobe.calling == nil then
		local userDetails = Inspect.Unit.Detail ('player')
		nkWardrobe.calling  = userDetails.calling
	end
	
	self:CreateUI()
	
	setmetatable(this, self)
	self.__index = self
	return this

end

function nkWardrobe.Config:Show(flag) self.frame:SetVisible(flag) end
function nkWardrobe.Config:IsVisible() return self.frame:isVisible() end

function nkWardrobe.Config:donateInfo()

	nkWardrobe.showMessage (nkWardrobe.langTexts.about.donate1 .. '\n' .. nkWardrobe.langTexts.about.donate2)

end

function nkWardrobe.Config:Close() 
	
	frame = self.frame.paneConfig
	if frame.fldValueSetName ~= nil then frame.fldValueSetName:leave() end
	
	self:Show(false) 
	
end

function nkWardrobe.Config:CreateUI()

	self.frame = UI.CreateFrame ('nkExtRiftWindow', 'nkWardrobeConfig', nkWardrobe.UIelements.context, {layer = 1, fontsize = 13, width = 700, height = 490, 
																										title = string.format(nkWardrobe.langTexts.txtHeader, nkWardrobe.privateVars.addonName, nkWardrobe.privateVars.addonVersion),
																										anchors = {{from = "CENTER", object = UIParent, to = "CENTER"}}, closeable = true, dragable = true, visible = true,
																										closeFunc = function() nkWardrobe.Config:Close() end})
		
	self.frame.closeButton = UI.CreateFrame ('nkExtRiftButton', 'nkWardrobeConfigbtClose', self.frame:getBody(true), { layer = 1, label = nkWardrobe.langTexts.btClose, anchors = {{from = "BOTTOMLEFT", object = self.frame:getBody(true), to = "BOTTOMLEFT", x = 15, y = -10}}, func = function () self:Close() end})
	self.frame.donateButton = UI.CreateFrame ('nkExtRiftButton', 'nkWardrobeConfigbtDonate', self.frame:getBody(true), { layer = 9, label = nkWardrobe.langTexts.btDonate, anchors = {{from = "CENTERLEFT", object = self.frame.closeButton:getElement(), to = "CENTERRIGHT", x = 10, y = 0}}, func = function () self:donateInfo() end})
	
	self.frame.paneConfig = UI.CreateFrame ('nkExtFrame', 'nkWardrobeConfigSets', self.frame:getBody(true), {visible = false})
	self.frame.paneButton = UI.CreateFrame ('nkExtFrame', 'nkWardrobeConfigButton', self.frame:getBody(true), {visible = false})
	self.frame.paneTabAbout = UI.CreateFrame ('nkExtFrame', 'nkWardrobeConfigAbout', self.frame:getBody(true), { visible = false})		
		
	self.frame.tabPane = UI.CreateFrame ('nkExtTabPane', 'configFrameTabPane', self.frame:getBody(), { fontsize = 14, width = 650, height = 400,  color = { body = "444444" , border = "000000" , label= "FFFFFF", inactive = "333333"}, 
										anchors = {{from = "TOPLEFT", object = self.frame:getBody(), to = "TOPLEFT", x = 10, y = 10}}, orientation = 'horizontal',
										headerWidth = 113, headerHeight = 28, headerOffsetX = 10, headerOffSetY = 0,
										bodyTexture = 'gfx/tabPaneBG.png',
										paneTextureAddon = 'nkWardrobe', paneTextureInactive = 'gfx/tabPaneHorizInActive.png', paneTextureActive = 'gfx/tabPaneHorizActive.png',							
										panes = {{content = self.frame.paneConfig, label = nkWardrobe.langTexts.tabHeader1, initFunc = function () self:SetupConfig() end},
												 {content = self.frame.paneButton, label = nkWardrobe.langTexts.tabHeader2, initFunc = function () self:SetupButton() end},
												 {content = self.frame.paneTabAbout, label = nkWardrobe.langTexts.tabHeader3, initFunc = function () self:SetupAbout() end}											
										}
										})

end

function nkWardrobe.Config:SetupConfig()

	local frame = self.frame.paneConfig
	
	frame.gridBG = UI.CreateFrame('nkExtTexture', 'nkWardrobeSetGridBG', frame:getElement(), { type = 'nkWardrobe', path = "gfx/setGridBG.png", width = 280, height = 300, anchors = {{ from = 'TOPLEFT', object = frame:getElement(true), to = "TOPLEFT", x = 10, y = 30}} })
	
	frame.grid = UI.CreateFrame('nkExtGrid', 'nkWardrobeSetGrid', frame:getElement(), { wheelFunc = function(counter) frame.slider:SetValue (counter) end, fontsize = 13, color = { headerBody = '', headerLabel = 'ECE4BD', label = 'FFFFFF', border = '000000', body = '222222', bodyhighlight = 'FFFFFF', labelhighlight = '000000'}, anchors = {{ from = 'TOPLEFT', object = frame.gridBG:getElement(true), to = "TOPLEFT", x = 7, y = 0}}, clickCallBack = function (colDef) self:editWardrobeSet(colDef) end })
	frame.grid:getElement():SetLayer(1)
	
	frame.grid:layout ({{align = 'left', header = nkWardrobe.langTexts.gridHeader, width = 249 }}, 13, {headerHeight = 25})
	
	frame.slider = UI.CreateFrame('nkExtScrollBox', 'nkWardrobeSetGridSlider', frame:getElement(), { visible = false, value = 1, color = { body = '222222', border = '000000' }, height = 260, anchors = {{ from = "TOPRIGHT", object = frame.gridBG:getElement(false), to = "TOPRIGHT", x = -4, y = 25}}, range = {1, 1},
																									 func = function (slider) frame.grid:setPos( math.floor(slider.value) ) end })
	frame.slider:getElement():SetLayer(1)
	self:wardrobeSetListUpdate()
	
	frame.fldValueSetName = UI.CreateFrame ('nkExtTextField', 'fldValueSetName', frame:getElement(true), { width = 200, value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].name, label = nkWardrobe.langTexts.fldSetName, anchors = {{ from = "TOPLEFT", object = frame.grid:getElement(), to = "TOPRIGHT", x = 32, y = 2 }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].name = value; self:wardrobeSetListUpdate() end, template = nkWardrobe.Config.fldTemplate})

	local selection = {{ label = string.format(nkWardrobe.langTexts.txtRole, 1), value = 1}, { label = string.format(nkWardrobe.langTexts.txtRole, 2), value = 2}, { label = string.format(nkWardrobe.langTexts.txtRole, 3), value = 3} , { label = string.format(nkWardrobe.langTexts.txtRole, 4), value = 4 }, { label = string.format(nkWardrobe.langTexts.txtRole, 5), value = 5 }, { label = string.format(nkWardrobe.langTexts.txtRole, 6), value = 6 }}
		
	frame.fldSelRoleLabel = UI.CreateFrame('nkExtText', 'fldSelRoleLabel', frame:getElement(), { width = 105, text = nkWardrobe.langTexts.fldRole, anchors = {{ from = "TOPLEFT", object = frame.fldValueSetName.element.label:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }}, template = nkWardrobe.Config.textTemplate })
	frame.fldSelRole = UI.CreateFrame('nkExtCombo', 'fldSelRole', frame:getElement(), { layer = 5, value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].role, width = 200, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelRoleLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].role = value end, template = nkWardrobe.Config.comboTemplate })
	
	local selection = {}	
	for idx = 1, #nkWardrobeSettings.equipSets, 1 do table.insert (selection, { label = nkWardrobeSettings.equipSets[idx].name, value = idx }) end

	frame.fldSelEquipmentLabel = UI.CreateFrame('nkExtText', 'fldSelEquipmentLabel', frame:getElement(), { width = 105, text = nkWardrobe.langTexts.fldEquipment, anchors = {{ from = "TOPLEFT", object = frame.fldSelRoleLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }}, template = nkWardrobe.Config.textTemplate })
	frame.fldSelEquipment = UI.CreateFrame('nkExtCombo', 'fldSelEquipment', frame:getElement(), { layer = 4, value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].equipment, width = 200, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelEquipmentLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].equipment = value end, template = nkWardrobe.Config.comboTemplate })
	
	local iconList = nkWardrobe.langTexts.souls[nkWardrobe.calling]
	
	local slot = Utility.Item.Slot.All()
	local items = Inspect.Item.Detail (slot)
	
	local nameList = {}
	
	for k, v in pairs (items) do				
		if nameList[v.name] ~= true then
			table.insert (iconList, { label = v.name, value = v.icon, iconType = 'Rift', iconPath = v.icon })
			nameList[v.name] = true
		end
	end
	
	frame.fldSelIconLabel = UI.CreateFrame('nkExtText', 'fldSelIconLabel', frame:getElement(), { width = 105, text = nkWardrobe.langTexts.fldIcon, anchors = {{ from = "TOPLEFT", object = frame.fldSelEquipmentLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }}, template = nkWardrobe.Config.textTemplate })
	frame.fldSelIcon = UI.CreateFrame('nkExtCombo', 'fldSelIcon', frame:getElement(), { layer = 3, value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].icon, width = 200, selection = iconList, anchors = {{ from = "CENTERLEFT", object = frame.fldSelIconLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].icon = value end, template = nkWardrobe.Config.comboTemplate })
	
	local addonList = Inspect.Addon.List()
	
	local subAnchor = {{ from = "TOPLEFT", object = frame.fldSelIconLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }}	
	
	if addonList.nkRebuff ~= nil then
		if nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].nkrebuff == nil then nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].nkrebuff = -1 end
	
		local selection = { { label = nkWardrobe.langTexts.deactivated, value = -1 } }
	
		local setList = nkRBAPI.getSets()
		for idx = 1, #setList, 1 do
			table.insert (selection, { value = idx, label = setList[idx].name })
		end
		
		frame.fldSelRebuffLabel = UI.CreateFrame('nkExtText', 'fldSelRebuffLabel', frame:getElement(), { width = 105, text = nkWardrobe.langTexts.fldRebuff, anchors = subAnchor, template = nkWardrobe.Config.textTemplate })
		frame.fldSelRebuff = UI.CreateFrame('nkExtCombo', 'fldSelRebuff', frame:getElement(), { layer = 2, value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].nkrebuff, width = 200, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelRebuffLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].nkrebuff = value end, template = nkWardrobe.Config.comboTemplate })
		
		subAnchor[1].object = frame.fldSelRebuffLabel:getElement()
	end
	
	if addonList.kAlert ~= nil then
		if nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KAMain == nil then nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KAMain = -1 end
		if nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KASub == nil then nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KASub = -1 end
	
		frame.fldSelKAMainLabel = UI.CreateFrame('nkExtText', 'fldSelKAsetMainLabel', frame:getElement(), { width = 105, text = nkWardrobe.langTexts.fldKASetMain, anchors = subAnchor, template = nkWardrobe.Config.textTemplate })
		frame.fldSelKASubLabel = UI.CreateFrame('nkExtText', 'fldSelKASetSubLabel', frame:getElement(), { width = 105, text = nkWardrobe.langTexts.fldKASetSub, anchors = {{ from = "TOPLEFT", object = frame.fldSelKAMainLabel:getElement(), to = "BOTTOMLEFT", x = 0, y = 5 }}, template = nkWardrobe.Config.textTemplate  })
		
		selection = { { label = nkWardrobe.langTexts.deactivated, value = -1 } }
		for idx = 0, 10, 1 do table.insert (selection, { label = string.format(nkWardrobe.langTexts.kaSet, idx), value = idx} ) end
		
		frame.fldSelKASub = UI.CreateFrame('nkExtCombo', 'fldSelKASub', frame:getElement(), { layer = 1, value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KASub, width = 200, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelKASubLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KASub = value end, template = nkWardrobe.Config.comboTemplate })
		
		selection = { { label = nkWardrobe.langTexts.deactivated, value = -1 } }
		for idx = 1, 6, 1 do table.insert (selection, { label = string.format(nkWardrobe.langTexts.kaSet, idx), value = idx} ) end
		
		frame.fldSelKAMain = UI.CreateFrame('nkExtCombo', 'fldSelKAMain', frame.fldSelKASub:getElement(), { layer = 1, value = nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KAMain, width = 200, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelKAMainLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.sets[nkWardrobeSettings.activeSet].KAMain = value end, template = nkWardrobe.Config.comboTemplate })
	end
											
	frame.delSetButton = UI.CreateFrame ('nkExtRiftButton', 'tab3DelSetButton', frame:getElement(true), { label = nkWardrobe.langTexts.btDelSet, anchors = {{from = "BOTTOMRIGHT", object = frame:getElement(), to = "BOTTOMRIGHT", x = -10, y = 0}},
											func = function () self:removeWardrobeSet() end, template = btTemplate})	
											
	frame.newSetButton = UI.CreateFrame ('nkExtRiftButton', 'newSetButton', frame:getElement(true), { label = nkWardrobe.langTexts.btNewSet, anchors = {{from = "CENTERRIGHT", object = frame.delSetButton:getElement(), to = "CENTERLEFT", x = -10, y = 0}},
											func = function () self:addWardrobeSet() end, template = btTemplate})	
	
end

function nkWardrobe.Config:SetupButton ()

	local frame = self.frame.paneButton
	
	local selection = {{ label = nkWardrobe.langTexts.openTop, value = 'top'}, { label = nkWardrobe.langTexts.openBottom, value = 'bottom'}, { label = nkWardrobe.langTexts.openLeft, value = 'left'} , { label = nkWardrobe.langTexts.openRight, value = 'right' } }

	frame.cbButton = UI.CreateFrame('nkExtCheckbox', 'cbButton', frame:getElement(), {	text = nkWardrobe.langTexts.cbButton, checked = nkWardrobeSettings.button, 
																						anchors = {{from = "TOPLEFT", object = frame:getElement(), to = "TOPLEFT", x= 15, y= 35}}, template = nkWardrobe.Config.cbTemplate,
																						func = function (this) nkWardrobeSettings.button = this:getChecked() end})
	
	frame.fldSelOpenLabel = UI.CreateFrame('nkExtText', 'fldSelOpenLabel', frame:getElement(), { width = 105, text = nkWardrobe.langTexts.fldOpen, anchors = {{ from = "TOPLEFT", object = frame.cbButton:getElement(), to = "BOTTOMLEFT", x = 0, y = 8 }}, template = nkWardrobe.Config.textTemplate })
	frame.fldSelOpen = UI.CreateFrame('nkExtCombo', 'fldSelIcon', frame:getElement(), { layer = 1, value = nkWardrobeSettings.open, width = 200, selection = selection, anchors = {{ from = "CENTERLEFT", object = frame.fldSelOpenLabel:getElement(), to = "CENTERRIGHT" }}, func = function (value) nkWardrobeSettings.open = value end,  template = nkWardrobe.Config.comboTemplate })
	frame.fldSelOpen:getElement():SetLayer(2)
	
	frame.slScale = UI.CreateFrame('nkExtSlider', 'slScale', frame:getElement(), {	text = string.format(nkWardrobe.langTexts.slScale, nkWardrobeSettings.scale), value = nkWardrobeSettings.scale, range = {50, 200}, width = 100, template = nkWardrobe.Config.cbTemplate,
																					anchors = {{from = "TOPLEFT", object = frame.fldSelOpenLabel:getElement(), to = "BOTTOMLEFT", x= 0, y= 5}}, labelinfront = true,
																					func = function(this) nkWardrobeSettings.scale = math.floor(this.value); this:update({ text = string.format(nkWardrobe.langTexts.slScale, nkWardrobeSettings.scale)}) end })

	frame.cbBorder = UI.CreateFrame('nkExtCheckbox', 'cbBorder', frame:getElement(), {text = nkWardrobe.langTexts.cbBorder, checked = nkWardrobeSettings.border, 
														anchors = {{from = "TOPLEFT", object = frame.slScale:getElement(), to = "BOTTOMLEFT", x= 0, y= 10}}, template = nkWardrobe.Config.cbTemplate,
														func = function (this) nkWardrobeSettings.border = this:getChecked() end})
											
	frame.delSetButton = UI.CreateFrame ('nkExtRiftButton', 'tab3DelSetButton', frame:getElement(true), { label = nkWardrobe.langTexts.btDelSet, anchors = {{from = "BOTTOMRIGHT", object = frame:getElement(), to = "BOTTOMRIGHT", x = -10, y = 0}},
											func = function () self:removeWardrobeSet() end, template = btTemplate})	
											
	frame.newSetButton = UI.CreateFrame ('nkExtRiftButton', 'newSetButton', frame:getElement(true), { label = nkWardrobe.langTexts.btNewSet, anchors = {{from = "CENTERRIGHT", object = frame.delSetButton:getElement(), to = "CENTERLEFT", x = -10, y = 0}},
											func = function () self:addWardrobeSet() end, template = btTemplate})	
	
end

function nkWardrobe.Config:SetupAbout()

	local frame = self.frame.paneTabAbout
	
	frame.addonNameShadow = UI.CreateFrame ('nkExtText', 'addonNameShadow', frame:getElement(), { layer = 1, text = string.format(nkWardrobe.langTexts.about.addonName, nkWardrobe.privateVars.addonName), fontsize = 30, color = '000000', anchors = {{ from = "TOPCENTER", object = frame:getElement(), to = "TOPCENTER", x = 2, y = 42 }} })
	frame.addonName = UI.CreateFrame ('nkExtText', 'addonName', frame:getElement(), { layer = 2, text = string.format(nkWardrobe.langTexts.about.addonName, nkWardrobe.privateVars.addonName), fontsize = 30, color = 'E7C878', anchors = {{ from = "TOPCENTER", object = frame:getElement(), to = "TOPCENTER", x = 0, y = 40 }} })
	
	frame.versionShadow = UI.CreateFrame ('nkExtText', 'versionShadow', frame:getElement(), { layer = 1, text = string.format(nkWardrobe.langTexts.about.version, nkWardrobe.privateVars.addonVersion), fontsize = 18, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.addonName:getElement(), to = "BOTTOMCENTER", x = 2, y = 2 }} })
	frame.version = UI.CreateFrame ('nkExtText', 'version', frame:getElement(), { layer = 2, text = string.format(nkWardrobe.langTexts.about.version, nkWardrobe.privateVars.addonVersion), fontsize = 18, color = 'E7C878', anchors = {{ from = "TOPCENTER", object = frame.addonName:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })

	frame.writtenBy = UI.CreateFrame ('nkExtText', 'writteBy', frame:getElement(), { layer = 1, text = nkWardrobe.langTexts.about.writtenBy, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.version:getElement(), to = "BOTTOMCENTER", x = 0, y = 10 }} })
	
	frame.copyright = UI.CreateFrame ('nkExtText', 'copyright', frame:getElement(), { layer = 1, text = nkWardrobe.langTexts.about.copyright, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.writtenBy:getElement(), to = "BOTTOMCENTER", x = 0, y = 10 }} })
	
	frame.translation = UI.CreateFrame ('nkExtText', 'copyright', frame:getElement(), { layer = 1, text = nkWardrobe.langTexts.about.russian .. ', ' .. nkWardrobe.langTexts.about.french, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.copyright:getElement(), to = "BOTTOMCENTER", x = 0, y = 10 }} }) 
		
	frame.donate1Shadow = UI.CreateFrame ('nkExtText', 'donate1Shadow', frame:getElement(), { layer = 1, text = nkWardrobe.langTexts.about.donate1, fontsize = 20, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.translation:getElement(), to = "BOTTOMCENTER", x = 2, y = 22 }} })
	frame.donate1 = UI.CreateFrame ('nkExtText', 'donate1', frame:getElement(), { layer = 2, text = nkWardrobe.langTexts.about.donate1, fontsize = 20, color = 'E7C878', anchors = {{ from = "TOPCENTER", object = frame.translation:getElement(), to = "BOTTOMCENTER", x = 0, y = 20 }} })
	
	frame.donate2Shadow = UI.CreateFrame ('nkExtText', 'donate2Shadow', frame:getElement(), { layer = 1, text = nkWardrobe.langTexts.about.donate2, fontsize = 20, color = '000000', anchors = {{ from = "TOPCENTER", object = frame.donate1:getElement(), to = "BOTTOMCENTER", x = 2, y = 2 }} })
	frame.donate2 = UI.CreateFrame ('nkExtText', 'donate2', frame:getElement(), { layer = 2, text = nkWardrobe.langTexts.about.donate2, fontsize = 20, color = 'E7C878', anchors = {{ from = "TOPCENTER", object = frame.donate1:getElement(), to = "BOTTOMCENTER", x = 0, y = 0 }} })

	frame.twitter = UI.CreateFrame ('nkExtText', 'twitter', frame:getElement(), { layer = 1, text = nkWardrobe.langTexts.about.twitter, fontsize = 16, color = 'FFFFFF', anchors = {{ from = "TOPCENTER", object = frame.donate2:getElement(), to = "BOTTOMCENTER", x = 0, y = 15 }} })		
		
end

function nkWardrobe.Config:editWardrobeSet(row)

	local frame = self.frame.paneConfig
	local grid = frame.grid	
	if grid.values[grid.counter+row-1] == nil then return end
	local name = grid.values[grid.counter + row - 1][1]
	
	for k, v in pairs (nkWardrobeSettings.sets) do
		if v.name == name then 
			nkWardrobeSettings.activeSet = k
			
			frame.fldValueSetName:setValue(v.name)
			frame.fldSelRole:setByValue(v.role)
			frame.fldSelEquipment:setByValue(v.equipment)
			frame.fldSelIcon:setByValue(v.icon)
			if frame.fldSelRebuff ~= nil then frame.fldSelRebuff:setByValue(v.nkrebuff) end
			if frame.fldSelKAMain ~= nil then frame.fldSelKAMain:setByValue(v.KAMain) end
			if frame.fldSelKASub ~= nil then frame.fldSelKASub:setByValue(v.KASub) end

			break
		end
	end
	
end

function nkWardrobe.Config:wardrobeSetListUpdate()

	local frame = self.frame.paneConfig
	local equipmentSets = {}
	
	for k, v in pairs (nkWardrobeSettings.sets) do table.insert (equipmentSets, {v.name}) end
	
	frame.grid:fill (equipmentSets)

	if (#equipmentSets-13) > 0 then	
		frame.slider:updateRange ({1, (#equipmentSets-12)})
		frame.slider:SetVisible(true)
	else
		frame.slider:SetVisible(false)
	end

end

function nkWardrobe.Config:addWardrobeSet()

	local counter = #nkWardrobeSettings.sets + 1
	table.insert (nkWardrobeSettings.sets, {name = string.format(nkWardrobe.langTexts.set, counter), role = 1, equipment = 1, nkrebuff = 1, icon = 1, KAMain = -1, KASub = -1 } )
	self:wardrobeSetListUpdate()
	
end

function nkWardrobe.Config:removeWardrobeSet()

	if #nkWardrobeSettings.sets == 1 then 
		self:errorMessage(nkWardrobe.langTexts.errLastSet)
	else
		local funcYes = function ()
			local frame = self.frame.paneConfig
			local grid = frame.grid	
			local name = frame.fldValueSetName:getValue()
			
			if #nkWardrobeSettings.sets <= 1 then return end
			
			for k, v in pairs (nkWardrobeSettings.sets) do
				if v.name == name then 
					table.remove (	nkWardrobeSettings.sets, k)
					break
				end
			end
			
			self:editWardrobeSet (1)
			self:wardrobeSetListUpdate()
		end
	
		if nkWardrobe.UIelements.confirmDialog == nil then
			nkWardrobe.UIelements.confirmDialog = UI.CreateFrame('nkExtDialog', 'nkWardrobeConfirmDialog', nkWardrobe.UIelements.context, { rdesign = true, layer = 2, width = 300, height = 125, confirmButton = true, color = {border = "000000", body = "333333", header = "3B5998", title = "FFFFFF", message = 'FFFFFF'}, 
																											title = string.format(nkWardrobe.langTexts.txtHeader, nkWardrobe.privateVars.addonName, nkWardrobe.privateVars.addonVersion), message = nkWardrobe.langTexts.msgRemoveSetConfirm, 
																											anchors = {{ from = "CENTER", object = UIParent, to = "CENTER"}}, funcYes = funcYes })
		else
			nkWardrobe.UIelements.confirmDialog:update ({ message = nkWardrobe.langTexts.msgRemoveSetConfirm, anchors = {{ from = "CENTER", object = UIParent, to = "CENTER"}}, funcYes = funcYes })
			nkWardrobe.UIelements.confirmDialog:SetVisible(true)
		end
	end

end
